chiark / gitweb /
dot/ipython-key-bindings.py: Hack IPython's bogus keybindings.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile lesskey sqliterc
137   parallel-config:.parallel/config
138   ipython-config.py:.ipython/profile_default/ipython_config.py
139   ipython-key-bindings.py:.ipython/profile_default/startup/50-key-bindings.py
140   ditz-config
141   mailrc signature muttrc
142   cgrc tigrc
143   gdbinit
144   guile
145   rcrc
146   toprc
147   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
148   pulse-daemon.conf:.pulse/daemon.conf
149   aspell.conf
150   tclshrc:.tclshrc tclshrc:.wishrc
151   lisp-init.lisp:.cmucl-init.lisp
152     lisp-init.lisp:.sbclrc
153     lisp-init.lisp:.clisprc.lisp
154     lisp-init.lisp:.eclrc
155   swank.lisp
156   mdw-build.conf:.config/mdw-build.conf
157   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
158   dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
159 [ "$xstuff" ] && dotfiles="$dotfiles
160   xinitrc xsession xmodmap vncrc vncsession
161   fonts.conf
162   stalonetrayrc
163   putty-defaults:.putty/sessions/Default%20Settings
164   mdw.session:.config/gnome-session/sessions/mdw.session
165   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
166   e-keybindings.cfg:.enlightenment/keybindings.cfg
167   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
168   e16-bindings:.e16/bindings.cfg
169   gtkrc-2.0
170   gtk3.css:.config/gtk-3.0/gtk.css
171   gtk3-settings.ini:.config/gtk-3.0/settings.ini"
172 echo "Installing dotfiles..."
173 for d in $dotfiles; do
174   target=.$d
175   case $d in
176     *:*) target=${d#*:} d=${d%%:*};;
177   esac
178   ft=$HOME$sub/$target
179   dir=${ft%/*}
180   mkdir -p $dir
181   ln -s $here/dot/$d $ft.new
182   mv $ft.new $ft
183   echo "  $target"
184 done
185 echo "  all done."
186
187 ## CPP-hack files which need it.
188 cppfiles=""
189 [ "$xstuff" ] && cppfiles="$cppfiles
190   Xdefaults"
191 echo "Hacking files with C preprocessor..."
192 defs="-DHOME=$HOME -DPROFILE=$here"
193 defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
194 for c in $cppfiles; do
195   target=.$c
196   case $c in
197     *:*) target=${c#*:} c=${c%%:*};;
198   esac
199   ft=$HOME$sub/$target
200   dir=${ft%/*}
201   mkdir -p $dir
202   cpp -P $defs dot/$c -o $ft.new
203   mv $ft.new $ft
204   echo "  $target"
205 done
206 echo "  all done."
207
208 ## Substitute things which need substituting.
209 dotfilessubst="
210   gitconfig
211   mykermrc
212   pulse-default.pa.in:.pulse/default.pa"
213 echo "Installing dotfiles with substitutions..."
214 for d in $dotfilessubst; do
215   case $d in
216     *:*) target=${d#*:} d=${d%%:*};;
217     *) target=.$d d=$d.in;;
218   esac
219   ft=$HOME$sub/$target
220   dir=${ft%/*}
221   mkdir -p $dir
222   sed "
223 1i\\
224 ### generated by $here/setup; do not edit!\\
225
226 /@home@/ s\a\a$HOME\ag
227 /@profile@/ s\a\a$here\ag
228 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
229 " dot/$d >$ft.new
230   mv $ft.new $ft
231   echo "  $target"
232 done
233 echo "  all done."
234
235 ## Symlink backgrounds.
236 backgrounds=$(cd bg && echo *)
237 if [ "$xstuff" ]; then
238   echo "Installing backgrounds..."
239   for b in $backgrounds; do
240     for e in enlightenment e16; do
241       dir=$HOME$sub/.$e/backgrounds
242       t=$dir/$b
243       mkdir -p $dir
244       ln -s $here/bg/$b $t.new
245       mv $t.new $t
246     done
247     echo "  $b"
248   done
249   echo "        all done."
250 fi
251
252 ###--------------------------------------------------------------------------
253 ### Install useful scripts included in this package.
254
255 scripts="
256   mdw-editor
257   mdw-pager
258   mdw-conf
259   mdw-build mdw-sbuild mdw-sbuild-server
260   update-buildable-branch
261   emacsclient-hack
262   movemail-hack
263   sendmail-hack
264   aspell-hack
265   emerge-hack
266   lesspipe.sh
267   run-with-shell-env
268   start-ssh-agent
269   start-ssh-pageant
270   add-ssh-keys
271   svnwrap
272   guest-console
273   hyperspec"
274 [ "$xstuff" ] && scripts="$scripts
275   xinitcmd
276   un-backslashify-selection
277   lock-screen
278   xpra-start-xdummy
279   xshutdown"
280 echo "Installing scripts..."
281 mkdir -p $HOME$sub/bin
282 for s in $scripts; do
283   ft=$HOME$sub/bin/$s
284   ln -s $here/bin/$s $ft.new
285   mv $ft.new $ft
286   echo "  $s"
287 done
288 echo "  all done."
289
290 hacks="
291   ssh:ssh"
292 echo "Installing hacks..."
293 for h in $hacks; do
294   d=${h%%:*} h=${h#*:}
295   ft=$HOME$sub/bin/hacks/$d
296   mkdir -p $ft
297   ln -s $here/hacks/$h $ft/$h.new
298   mv $ft/$h.new $ft/$h
299   echo "  $d:$h"
300 done
301 echo "  all done."
302
303 ###--------------------------------------------------------------------------
304 ### Set up the Emacs config.
305
306 $echon "Finding a suitable emacs:$echoc"
307 emacs=no
308 for i in emacs24 emacs23 emacs22 emacs21 emacs; do
309   if type -p >/dev/null $i; then
310     emacs=$i
311     break
312   fi
313 done
314 if [ $emacs = no ]; then
315   echo " failed."
316   emacs=:
317 else
318   echo " $emacs."
319 fi
320
321 echo "Installing Emacs packages..."
322 emacspkg="
323   make-regexp
324   ew-hols
325   mdw-gnus-patch
326   git git-blame vc-git stgit
327   mdw-multiple-cursors
328   quilt"
329 for elib in $emacspkg; do
330   $echon "  $elib:$echoc"
331   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
332        (progn
333          (setq load-path (nconc load-path (list "~/lib/emacs")))
334          (kill-emacs (condition-case nil
335                          (progn (load-library "'"$elib"'") 0)
336                        (error 1))))'; then
337     echo " already installed."
338   else
339     if [ -f el/$elib.el ]; then
340       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
341     else
342       $echon " downloading$echoc"
343       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
344     fi
345     $echon " compiling$echoc"
346     (cd $HOME$sub/lib/emacs;
347       $emacs >/dev/null 2>&1 --no-site-file --batch \
348         --eval '(byte-compile-file "'"$elib.el"'")')
349     echo " done."
350   fi
351 done
352 echo "  all done."
353
354 $echon "Setting up Emacs configuration:$echoc"
355 $echon " linking$echoc"
356 for f in dot-emacs.el Makefile; do
357   set -- $(echo $link | tr : ' ')
358   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
359   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
360 done
361 $echon " compiling$echoc"
362 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
363 echo " done."
364
365 ###----- That's all, folks --------------------------------------------------